Index: /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.env
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.env	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.env	(revision 1134)
@@ -0,0 +1,9 @@
+module unload netcdf
+module unload hdf5
+
+export HDF5_INC_DIR=$HOME/lib/hdf5_intel/include
+export HDF5_LIB_DIR=$HOME/lib/hdf5_intel/lib
+
+export NETCDF_INC_DIR=$HOME/lib/netcdf_intel/include
+export NETCDF_LIB_DIR=$HOME/lib/netcdf_intel/lib
+
Index: /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.fcm
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.fcm	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.fcm	(revision 1134)
@@ -0,0 +1,24 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc -openmp -D_intelmpi -D_usingEP  
+%FCOMPILER      mpif90 -openmp
+%LINKER         mpif90 -openmp -Wl,-rpath -Wl,$HOME/lib/netcdf_f_intel/lib
+
+%BASE_CFLAGS    -ansi -w -lcurl
+%PROD_CFLAGS    -O3 -DBOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -g -O2 
+%DEBUG_CFLAGS   -g -inline-debug-info -traceback 
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2
+%DEBUG_FFLAGS   -g 
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            cpp
+%FPP            cpp -P
+%MAKE           gmake
Index: /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.path
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.path	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-CURIE_Intel.path	(revision 1134)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR -I $HOME/lib/netcdf_f_intel/include"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR -L $HOME/lib/netcdf_f_intel/lib"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -ldl -lcurl"
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
Index: /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.env
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.env	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.env	(revision 1134)
@@ -1,6 +1,7 @@
-export HDF5_INC_DIR=$HOME/hdf5/include
-export HDF5_LIB_DIR=$HOME/hdf5/lib
 
-export NETCDF_INC_DIR=$HOME/netcdf4/include
-export NETCDF_LIB_DIR=$HOME/netcdf4/lib
+export HDF5_INC_DIR=$HOME/lib/hdf5/include
+export HDF5_LIB_DIR=$HOME/lib/hdf5/lib
 
+export NETCDF_INC_DIR=$HOME/lib/netcdf/include
+export NETCDF_LIB_DIR=$HOME/lib/netcdf/lib
+
Index: /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.fcm
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.fcm	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.fcm	(revision 1134)
@@ -3,7 +3,7 @@
 ################################################################################
 
-%CCOMPILER      mpicc
-%FCOMPILER      mpif90
-%LINKER         mpif90  
+%CCOMPILER      mpicc -fopenmp -D_openmpi -D_usingEP 
+%FCOMPILER      mpif90 -fopenmp
+%LINKER         mpif90 -fopenmp -D_openmpi -D_usingEP 
 
 %BASE_CFLAGS    -ansi -w
Index: /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.path
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.path	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-GCC_LINUX.path	(revision 1134)
@@ -1,13 +1,13 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF_INCDIR="-I $NETCDF_INC_DIR -I $HOME/lib/netcdf_f/include"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR -L $HOME/lib/netcdf_f/lib"
+NETCDF_LIB=" -lnetcdf"
 
-MPI_INCDIR=""
-MPI_LIBDIR=""
+MPI_INCDIR="-I /usr/local/include"
+MPI_LIBDIR="-L /usr/local/lib"
 MPI_LIB=""
 
 HDF5_INCDIR="-I $HDF5_INC_DIR"
 HDF5_LIBDIR="-L $HDF5_LIB_DIR"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -ldl -lcurl"
 
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
Index: /XIOS/dev/branch_yushan_merged/arch/arch-X64_ADA.fcm
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-X64_ADA.fcm	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-X64_ADA.fcm	(revision 1134)
@@ -3,7 +3,7 @@
 ################################################################################
 
-%CCOMPILER      mpiicc
-%FCOMPILER      mpiifort 
-%LINKER         mpiifort  -nofor-main
+%CCOMPILER      mpiicc -qopenmp -D_usingEP -D_intelmpi
+%FCOMPILER      mpiifort -qopenmp -D_usingEP -D_intelmpi
+%LINKER         mpiifort  -nofor-main -qopenmp -D_usingEP -D_intelmpi
 
 %BASE_CFLAGS    -diag-disable 1125 -diag-disable 279
Index: /XIOS/dev/branch_yushan_merged/arch/arch-X64_CURIE.fcm
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-X64_CURIE.fcm	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-X64_CURIE.fcm	(revision 1134)
@@ -3,6 +3,6 @@
 ################################################################################
 
-%CCOMPILER      mpicc
-%FCOMPILER      mpif90
+%CCOMPILER      mpicc -openmp -D_openmpi -D_usingEP
+%FCOMPILER      mpif90 -openmp -D_openmpi -D_usingEP
 %LINKER         mpif90  -nofor-main
 
Index: /XIOS/dev/branch_yushan_merged/arch/arch-local.env
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-local.env	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-local.env	(revision 1134)
@@ -0,0 +1,7 @@
+
+export HDF5_INC_DIR=$HOME/LIB/hdf5-1.8.16/hdf5/include
+export HDF5_LIB_DIR=$HOME/LIB/hdf5-1.8.16/hdf5/lib
+
+export NETCDF_INC_DIR=/usr/local/include
+export NETCDF_LIB_DIR=/usr/local/lib
+
Index: /XIOS/dev/branch_yushan_merged/arch/arch-local.fcm
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-local.fcm	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-local.fcm	(revision 1134)
@@ -0,0 +1,24 @@
+################################################################################
+###################                Projet XIOS               ###################
+################################################################################
+
+%CCOMPILER      mpicc -fopenmp -D_openmpi -D_usingEP 
+%FCOMPILER      mpif90 -fopenmp
+%LINKER         mpif90 -fopenmp -D_openmpi -D_usingEP 
+
+%BASE_CFLAGS    -ansi -w -D_GLIBCXX_USE_CXX11_ABI=0
+%PROD_CFLAGS    -O3 -DBOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -g -O2 
+%DEBUG_CFLAGS   -g 
+
+%BASE_FFLAGS    -D__NONE__ 
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2
+%DEBUG_FFLAGS   -g 
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++
+
+%CPP            cpp
+%FPP            cpp -P
+%MAKE           make
Index: /XIOS/dev/branch_yushan_merged/arch/arch-local.path
===================================================================
--- /XIOS/dev/branch_yushan_merged/arch/arch-local.path	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/arch/arch-local.path	(revision 1134)
@@ -0,0 +1,15 @@
+NETCDF_INCDIR="-I $NETCDF_INC_DIR"
+NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_LIB=" -lnetcdf"
+
+MPI_INCDIR=""
+MPI_LIBDIR=""
+MPI_LIB=""
+
+HDF5_INCDIR="-I $HDF5_INC_DIR"
+HDF5_LIBDIR="-L $HDF5_LIB_DIR"
+HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -ldl "
+
+OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
+OASIS_LIBDIR="-L$PWD/../../oasis3-mct/BLD/lib"
+OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
Index: /XIOS/dev/branch_yushan_merged/bld.cfg
===================================================================
--- /XIOS/dev/branch_yushan_merged/bld.cfg	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/bld.cfg	(revision 1134)
@@ -29,12 +29,14 @@
 src::netcdf $PWD/extern/netcdf4
 src::remap $PWD/extern/remap/src
+src::src_ep_dev $PWD/extern/src_ep_dev
 bld::lib xios
-bld::target libxios.a 
+#bld::target libxios.a 
 #bld::target generate_fortran_interface.exe 
-bld::target xios_server.exe 
+#bld::target xios_server.exe 
 #bld::target test_remap.exe
 #bld::target test_regular.exe
 #bld::target test_expand_domain.exe
 #bld::target test_new_features.exe test_unstruct_complete.exe 
+bld::target test_omp.exe test_complete_omp.exe
 bld::target test_client.exe test_complete.exe test_xios2_cmip6.exe
 #bld::target test_connectivity_expand.exe
@@ -66,2 +68,3 @@
 bld::excl_dep        use::netcdf
 bld::excl_dep        inc::mpif.h
+bld::excl_dep        use::omp_lib
Index: /XIOS/dev/branch_yushan_merged/extern/remap/src/mapper.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/remap/src/mapper.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/extern/remap/src/mapper.hpp	(revision 1134)
@@ -3,4 +3,8 @@
 #include "parallel_tree.hpp"
 #include "mpi.hpp"
+
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace sphereRemap {
@@ -18,5 +22,5 @@
 {
 public:
-       Mapper(MPI_Comm comm=MPI_COMM_WORLD) : communicator(comm), verbose(SILENT), neighbourElements(NULL), sstree(comm) {}
+       Mapper(ep_lib::MPI_Comm comm=MPI_COMM_WORLD) : communicator(comm), verbose(SILENT), neighbourElements(NULL), sstree(comm) {}
        ~Mapper();
        void setVerbosity(verbosity v) {verbose=v ;}
@@ -67,5 +71,5 @@
 
        CParallelTree sstree;
-       MPI_Comm communicator ;
+       ep_lib::MPI_Comm communicator ;
        std::vector<Elt>  sourceElements ;
        std::vector<Node> sourceMesh ;
Index: /XIOS/dev/branch_yushan_merged/extern/remap/src/mpi_routing.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/remap/src/mpi_routing.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/extern/remap/src/mpi_routing.cpp	(revision 1134)
@@ -5,4 +5,7 @@
 #include "timerRemap.hpp"
 #include <iostream>
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace sphereRemap {
@@ -122,6 +125,8 @@
 	CTimer::get("CMPIRouting::init(reduce_scatter)").print();
 
-	MPI_Alloc_mem(nbTarget *sizeof(int), MPI_INFO_NULL, &targetRank);
-	MPI_Alloc_mem(nbSource *sizeof(int), MPI_INFO_NULL, &sourceRank);
+	MPI_Info info_null;
+
+	MPI_Alloc_mem(nbTarget *sizeof(int), info_null, &targetRank);
+	MPI_Alloc_mem(nbSource *sizeof(int), info_null, &sourceRank);
 
 	targetRankToIndex = new int[mpiSize];
@@ -150,5 +155,9 @@
 	for (int i = 0; i < nbSource; i++)
 	{
+		#ifdef _usingEP
+		MPI_Irecv(&sourceRank[i], 1, MPI_INT, -1, 0, communicator, &request[indexRequest]);
+		#else
 		MPI_Irecv(&sourceRank[i], 1, MPI_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest]);
+		#endif
 		indexRequest++;
 	}
@@ -170,5 +179,9 @@
 	for (int i = 0; i < nbSource; i++)
 	{
+		#ifdef _usingEP
+		MPI_Irecv(&sourceRank[i], 1, MPI_INT, -1, 0, communicator, &request[indexRequest]);
+		#else
 		MPI_Irecv(&sourceRank[i], 1, MPI_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest]);
+		#endif
 		indexRequest++;
 	}
Index: /XIOS/dev/branch_yushan_merged/extern/remap/src/parallel_tree.hpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/remap/src/parallel_tree.hpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/extern/remap/src/parallel_tree.hpp	(revision 1134)
@@ -6,4 +6,7 @@
 #include "mpi_cascade.hpp"
 #include "mpi.hpp"
+#ifdef _usingEP
+#include "ep_declaration.hpp"
+#endif
 
 namespace sphereRemap {
@@ -12,5 +15,5 @@
 {
 public:
-	CParallelTree(MPI_Comm comm);
+	CParallelTree(ep_lib::MPI_Comm comm);
 	~CParallelTree();
 
@@ -34,5 +37,5 @@
 	vector<CSampleTree> treeCascade; // first for sample tree, then for routing tree
 	CMPICascade cascade;
-  MPI_Comm communicator ;
+        ep_lib::MPI_Comm communicator ;
 
 };
Index: /XIOS/dev/branch_yushan_merged/extern/remap/src/tree.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/remap/src/tree.cpp	(revision 1133)
+++ /XIOS/dev/branch_yushan_merged/extern/remap/src/tree.cpp	(revision 1134)
@@ -142,6 +142,8 @@
 	root->parent = 0;
 	root->leafCount = 0;
-// initialize root node on the sphere
-  root->centre.x=1 ; root->centre.y=0 ; root->centre.z=0 ; 
+        // initialize root node on the sphere
+        root->centre.x=1 ; 
+        root->centre.y=0 ; 
+        root->centre.z=0 ; 
 	root->radius = 0.;
 	root->reinserted = false;
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_alltoall.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_alltoall.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_alltoall.cpp	(revision 1134)
@@ -0,0 +1,25 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+//#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+
+
+  int MPI_Alltoall(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
+  {
+    ::MPI_Aint typesize, llb;
+    ::MPI_Type_get_extent(static_cast< ::MPI_Datatype>(sendtype), &llb, &typesize);
+
+    for(int i=0; i<comm.ep_comm_ptr->size_rank_info[0].second; i++)
+    {
+      MPI_Gather((char*)sendbuf+i*sendcount*typesize, sendcount, sendtype, recvbuf, recvcount, recvtype, i, comm);
+    }
+
+    return 0;
+  }
+
+}
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_barrier.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_barrier.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_barrier.cpp	(revision 1134)
@@ -0,0 +1,69 @@
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+namespace ep_lib
+{
+
+  int MPI_Barrier(MPI_Comm comm)
+  {
+    if(comm.is_intercomm) return MPI_Barrier_intercomm(comm);
+
+    if(comm.is_ep)
+    {
+      int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+
+      MPI_Barrier_local(comm);
+
+      if(ep_rank_loc == 0)
+      {
+        ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.mpi_comm);
+
+        ::MPI_Barrier(mpi_comm);
+      }
+
+      MPI_Barrier_local(comm);
+
+      return 0;
+    }
+    else if(comm.mpi_comm != MPI_COMM_NULL_STD )
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm> (comm.mpi_comm);
+      ::MPI_Barrier(mpi_comm);
+      return 0;
+    }
+
+    else return 0;
+  }
+
+
+  int MPI_Barrier_intercomm(MPI_Comm comm)
+  {
+
+    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+
+    MPI_Barrier_local(comm);
+
+    if(ep_rank_loc == 0)
+    {
+      ::MPI_Comm mpi_comm = static_cast< ::MPI_Comm > (comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+      ::MPI_Barrier(mpi_comm);
+    }
+
+    MPI_Barrier_local(comm);
+
+    return 0;
+
+  }
+
+
+  int MPI_Barrier_local(MPI_Comm comm)
+  {
+    Message_Check(comm);
+    comm.ep_barrier->wait();
+  }
+
+
+}
+
+
Index: /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_bcast.cpp
===================================================================
--- /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_bcast.cpp	(revision 1134)
+++ /XIOS/dev/branch_yushan_merged/extern/src_ep_dev/ep_bcast.cpp	(revision 1134)
@@ -0,0 +1,307 @@
+/*!
+   \file ep_bcast.cpp
+   \since 2 may 2016
+
+   \brief Definitions of MPI collective function: MPI_Bcast
+ */
+
+#include "ep_lib.hpp"
+#include <mpi.h>
+#include "ep_declaration.hpp"
+
+using namespace std;
+
+
+namespace ep_lib
+{
+  int MPI_Bcast_local(void *buffer, int count, MPI_Datatype datatype, MPI_Comm comm)
+  {
+    if(datatype == MPI_INT)
+    {
+      return MPI_Bcast_local_int(buffer, count, comm);
+    }
+    else if(datatype == MPI_FLOAT)
+    {
+      return MPI_Bcast_local_float(buffer, count, comm);
+    }
+    else if(datatype == MPI_DOUBLE)
+    {
+      return MPI_Bcast_local_double(buffer, count, comm);
+    }
+    else if(datatype == MPI_CHAR)
+    {
+      return MPI_Bcast_local_char(buffer, count, comm);
+    }
+    else if(datatype == MPI_LONG)
+    {
+      return MPI_Bcast_local_long(buffer, count, comm);
+    }
+    else if(datatype == MPI_UNSIGNED_LONG)
+    {
+      return MPI_Bcast_local_char(buffer, count, comm);
+    }
+    else
+    {
+      printf("MPI_Bcast Datatype not supported!\n");
+      exit(0);
+    }
+  }
+
+  int MPI_Bcast_local_int(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    int *buffer = comm.my_buffer->buf_int;
+    int *tmp = static_cast<int*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_float(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    float *buffer = comm.my_buffer->buf_float;
+    float *tmp = static_cast<float*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_double(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    double *buffer = comm.my_buffer->buf_double;
+    double *tmp = static_cast<double*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+
+  int MPI_Bcast_local_char(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    char *buffer = comm.my_buffer->buf_char;
+    char *tmp = static_cast<char*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_long(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    long *buffer = comm.my_buffer->buf_long;
+    long *tmp = static_cast<long*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+  int MPI_Bcast_local_ulong(void *buf, int count, MPI_Comm comm)
+  {
+    int my_rank = comm.ep_comm_ptr->size_rank_info[1].first;
+    int num_ep  = comm.ep_comm_ptr->size_rank_info[1].second;
+
+    unsigned long *buffer = comm.my_buffer->buf_ulong;
+    unsigned long *tmp = static_cast<unsigned long*>(buf);
+
+    for(int j=0; j<count; j+=BUFFER_SIZE)
+    {
+      if(my_rank == 0)
+      {
+        #pragma omp critical (write_to_buffer)
+        {
+          copy(tmp+j, tmp+j+min(BUFFER_SIZE, count-j), buffer);
+        }
+        #pragma omp flush
+      }
+
+      MPI_Barrier_local(comm);
+
+
+      if(my_rank != 0)
+      {
+        #pragma omp flush
+        #pragma omp critical (read_from_buffer)
+        {
+          copy(buffer, buffer+min(BUFFER_SIZE, count-j), tmp+j);
+        }
+      }
+
+      MPI_Barrier_local(comm);
+    }
+  }
+
+
+  int MPI_Bcast(void *buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm)
+  {
+
+    if(!comm.is_ep)
+    {
+      ::MPI_Bcast(buffer, count, static_cast< ::MPI_Datatype>(datatype), root, static_cast< ::MPI_Comm>(comm.mpi_comm));
+      return 0;
+    }
+
+
+    int ep_rank, ep_rank_loc, mpi_rank;
+    int ep_size, num_ep, mpi_size;
+
+    ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
+    ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
+    num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+
+
+
+    int root_mpi_rank = comm.rank_map->at(root).second;
+    int root_ep_rank_loc = comm.rank_map->at(root).first;
+
+
+    // if root is not master thread, send first to master
+    if(root_ep_rank_loc != 0 && mpi_rank == root_mpi_rank)
+    {
+      innode_memcpy(root_ep_rank_loc, buffer, 0, buffer, count, datatype, comm);
+    }
+
+
+    if(ep_rank_loc==0)
+    {
+      ::MPI_Bcast(buffer, count, static_cast< ::MPI_Datatype>(datatype), root_mpi_rank, static_cast< ::MPI_Comm>(comm.mpi_comm));
+    }
+
+    MPI_Bcast_local(buffer, count, datatype, comm);
+
+    return 0;
+  }
+
+
+}
